require 'sketchup.rb'
def clean_selection(entities)
	#UI.messagebox "cleaning"
	trash = []
	Sketchup.active_model.start_operation "Clean Selection"
	selection = Sketchup.active_model.selection
	if (entities)
		selection.clear
		selection.add entities
	end
	selection.each {|looptemp|trash.push(looptemp) if (looptemp.typename == "Edge" && looptemp.faces.length == 0)}
	selection.each {|looptemp|trash.push(looptemp) if (looptemp.typename == "Edge" && looptemp.faces.length == 2 && looptemp.faces[0].material == looptemp.faces[1].material && (looptemp.faces[0].plane == looptemp.faces[1].plane))}
	#puts trash.inspect
	trash.each {|looptemp|Sketchup.active_model.entities.erase_entities(looptemp)}
	#UI.messagebox "done"
	Sketchup.active_model.commit_operation
	return
end
def connect_rails(leftpoints, rightpoints, reversable)#must give it two ordered sets or vertices
	#redone = false
	#begin
	rightnext = nil
	leftnext = nil
	forepoint = nil
	backpoints = []
	thesefaces = []
	leftpoint = leftpoints.shift
	leftnext = leftpoints.shift
	rightpoints.reverse! if (rightpoints.first.position.distance(leftpoint) > rightpoints.last.position.distance(leftpoint) && reversable)
	rightpoint = rightpoints.shift
	rightnext = rightpoints.shift
	while (true)
		backpoints = [leftpoint, rightpoint]
		leftnext = leftpoints.shift if (leftnext == nil)
		rightnext = rightpoints.shift if (rightnext == nil)
		if ([leftnext, rightnext] == [nil, nil])
			#UI.messagebox "section done"
			return thesefaces
		elsif (leftnext == nil || (rightnext != nil && rightnext.position.distance(leftpoint) < leftnext.position.distance(rightpoint)))
			forepoint = rightnext
			rightpoint = rightnext
			rightnext = nil
		elsif (leftnext != nil)
			forepoint = leftnext
			leftpoint = leftnext
			leftnext = nil
		end
		#UI.messagebox "!"
		thesefaces.push(Sketchup.active_model.entities.add_face([backpoints, forepoint].flatten))
	end
	#rescue
	#	rightpoints.reverse!
	#	reversable = false
	#	if (redone == false)
	#		redone = true
	#		retry
	#	end
	#end
end
def get_points(startpoint, lines)#must have a starting point as first element in array
	#puts lines.inspect
	points = [startpoint]
	points.push (((lines.delete((points.last.edges & lines)[0])).vertices.reject{|looptemp|looptemp == points.last})[0]) while ((points.last.edges & lines).length != 0)
	#puts points.inspect
	return(points)
end
def skin
	errorm = "An error occurred. The next version will hopefully fix the one that you are experiencing. Version 3.0 is the next planned errorless one."
	selection = Sketchup.active_model.selection#I start with just this.
	section = []
	side = []
	sides = []
	sidesets = []#Then I organize the selection into this.
	allfaces = []#This is where all the new data goes so that I can "clean" it up.
	sidefaces = []#This holds all the faces in "selection" for certain uses.
	alledges = []
	rightedges = []#This holds one side from "sidesets" for quick access.
	leftedges = []#This holds the other side from "sidesets".
	leftpoints = []
	rightpoints = []
	prepedpoints = []#This holds the points, all organized, grouped, and ready for connection.
	intersections = []#This holds all the points with more than 2 selected edges.
	ends = []#And this holds all the points with only 1 selected edge.
	selection.each {|looptemp| alledges.push(looptemp)}
	sidefaces = alledges.reject{|looptemp| looptemp.typename != "Face"}
	allfaces = sidefaces
	alledges.reject!{|looptemp| looptemp.typename != "Edge"}
	while (alledges.length > 0)
		side.push(alledges.pop)
		side.each do
			|looptemp|
			looptemp.vertices.each do
				|loopt|
				(loopt.edges & alledges).each do
					|lpt|
					side.push lpt
					alledges.delete lpt
				end
			end
		end
		sides.push(side + [])
		side.clear
	end
	UI.messagebox "You must have selected more than you wanted to, it is not all in two groups. Currently I'm taking two random ones but future versions will deal differently with this issue" if (sides.length > 2)
	sidesets.push([sides[0], sides[1], sidefaces])
	Sketchup.active_model.start_operation "Skin"
	sidesets.each do
		|set|
		rightedges = set[0]
		leftedges = set[1]
		sidefaces = set[2]
		rightpoints = rightedges.collect{|looptemp| looptemp.vertices}.flatten.uniq
		leftpoints = leftedges.collect{|looptemp| looptemp.vertices}.flatten.uniq
		intersections = (rightpoints + leftpoints).reject{|looptemp|(looptemp.edges & (rightedges + leftedges)).length < 3}
		ends = (rightpoints + leftpoints).reject{|looptemp|(looptemp.edges & (rightedges + leftedges)).length != 1}
		if (intersections.length > 0)
			UI.messagebox errorm
		elsif (ends.length == 0)#split one side at point nearest to start of other side
			leftpoints = get_points(leftpoints.sort{|a,b|a.position.distance(rightpoints.first) <=> b.position.distance(rightpoints.first)}[0], leftedges)
			rightpoints = get_points(rightpoints.first, rightedges)
			allfaces.push(connect_rails(leftpoints, rightpoints, true))
		elsif ([(leftpoints & ends).length, (rightpoints & ends).length] == [2, 2])# just plain old connect them
			leftpoints = get_points((leftpoints & ends)[0], leftedges)
			rightpoints = get_points((rightpoints & ends)[0], rightedges)
			allfaces.push(connect_rails(leftpoints, rightpoints, true))
		else
			UI.messagebox errorm
		end
	end
	allfaces.flatten!
	allfaces.collect!{|looptemp| [looptemp.edges, looptemp]}
	allfaces.flatten!
	allfaces.uniq
	clean_selection allfaces
	Sketchup.active_model.commit_operation
	return true
end#then comes the setup
skin = SketchupExtension.new "Skin", "skin.rb"
skin.description = "A tool that takes two selected sets of entities and connects them, hopefully..."
skin.version = "2.0"
skin.creator = "Darrel Belvin, Toolbar Icons were done by Baz"
skin.copyright = "2007, Darrel Belvin"
skinc = UI::Command.new("Skin") {skin()}
skinc.small_icon = "skin/skinS.png"
skinc.large_icon = "skin/skin.png"
skinc.tooltip = "Connects the two selected sides."
cleanc = UI::Command.new("Clean") {clean_selection(nil)}
cleanc.small_icon = "skin/cleanS.png"
cleanc.large_icon = "skin/clean.png"
cleanc.tooltip = "Removes all coplanar or empty selected edges."
if not (file_loaded? "skin.rb")
	add_separator_to_menu("Tools")
	dbtoolsm = UI.menu("Tools").add_submenu("D.B.Tools")
		dbtoolsm.add_item("Clean Selection") {clean_selection(nil)}
		dbtoolsm.add_item("Skin") {skin()}
	Sketchup.register_extension skin
	DBTools = UI::Toolbar.new("D.B. Tools")
	DBTools.add_item(skinc)
	DBTools.add_item(cleanc)
end
file_loaded("skin.rb")